var has_h264=""
var sr=new Array()

try{
  has_h264=document.createElement("video").canPlayType('video/mp4; codecs="avc1.42E01E"') .replace(/^no$/,"")
} catch(e){
}

var LZW = {
  encode:function(s) {
    var dict = {};
    var data = (s + "").split("");
    var out = [];
    var currChar;
    var phrase = data[0];
    var code = 256;
    for (var i=1; i<data.length; i++) {
        currChar=data[i];
        if (dict[phrase + currChar] != null) {
            phrase += currChar;
        }
        else {
            out.push(phrase.length > 1 ? dict[phrase] : phrase.charCodeAt(0));
            dict[phrase + currChar] = code;
            code++;
            phrase=currChar;
        }
    }
    out.push(phrase.length > 1 ? dict[phrase] : phrase.charCodeAt(0));
    for (var i=0; i<out.length; i++) {
        out[i] = String.fromCharCode(out[i]);
    }
    return out.join("");
  },
  decode:function(s) {
    var dict = {};
    var data = (s + "").split("");
    var currChar = data[0];
    var oldPhrase = currChar;
    var out = [currChar];
    var code = 256;
    var phrase;
    for (var i=1; i<data.length; i++) {
        var currCode = data[i].charCodeAt(0);
        if (currCode < 256) {
            phrase = data[i];
        }
        else {
           phrase = dict[currCode] ? dict[currCode] : (oldPhrase + currChar);
        }
        out.push(phrase);
        currChar = phrase.charAt(0);
        dict[code] = oldPhrase + currChar;
        code++;
        oldPhrase = phrase;
    }
    return out.join("");
  }
}

var Base64 = {
	// private property
	_keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",
	// public method for encoding
	encode : function (input) {
		var output = "";
		var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
		var i = 0;
		input = Base64._utf8_encode(input);
		while (i < input.length) {
			chr1 = input.charCodeAt(i++);
			chr2 = input.charCodeAt(i++);
			chr3 = input.charCodeAt(i++);
			enc1 = chr1 >> 2;
			enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
			enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
			enc4 = chr3 & 63;
			if (isNaN(chr2)) {
				enc3 = enc4 = 64;
			} else if (isNaN(chr3)) {
				enc4 = 64;
			}
			output = output +
			this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
			this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);
		}
		return output;
	},
	// public method for decoding
	decode : function (input) {
		var output = "";
		var chr1, chr2, chr3;
		var enc1, enc2, enc3, enc4;
		var i = 0;
		input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
		while (i < input.length) {
			enc1 = this._keyStr.indexOf(input.charAt(i++));
			enc2 = this._keyStr.indexOf(input.charAt(i++));
			enc3 = this._keyStr.indexOf(input.charAt(i++));
			enc4 = this._keyStr.indexOf(input.charAt(i++));
			chr1 = (enc1 << 2) | (enc2 >> 4);
			chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
			chr3 = ((enc3 & 3) << 6) | enc4;
			output = output + String.fromCharCode(chr1);
			if (enc3 != 64) {
				output = output + String.fromCharCode(chr2);
			}
			if (enc4 != 64) {
				output = output + String.fromCharCode(chr3);
			}
		}
		output = Base64._utf8_decode(output);
		return output;
	},
	// private method for UTF-8 encoding
	_utf8_encode : function (string) {
		string = string.replace(/\r\n/g,"\n");
		var utftext = "";
		for (var n = 0; n < string.length; n++) {
			var c = string.charCodeAt(n);
			if (c < 128) {
				utftext += String.fromCharCode(c);
			}
			else if((c > 127) && (c < 2048)) {
				utftext += String.fromCharCode((c >> 6) | 192);
				utftext += String.fromCharCode((c & 63) | 128);
			}
			else {
				utftext += String.fromCharCode((c >> 12) | 224);
				utftext += String.fromCharCode(((c >> 6) & 63) | 128);
				utftext += String.fromCharCode((c & 63) | 128);
			}
		}
		return utftext;
	},
	// private method for UTF-8 decoding
	_utf8_decode : function (utftext) {
		var string = "";
		var i = 0;
		var c,c3,c2;
    c = c3 = c2 = 0;
		while ( i < utftext.length ) {
			c = utftext.charCodeAt(i);
			if (c < 128) {
				string += String.fromCharCode(c);
				i++;
			}
			else if((c > 191) && (c < 224)) {
				c2 = utftext.charCodeAt(i+1);
				string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
				i += 2;
			}
			else {
				c2 = utftext.charCodeAt(i+1);
				c3 = utftext.charCodeAt(i+2);
				string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
				i += 3;
			}
		}
		return string;
	}
}

var videoCnt=0;
var autoPlay=false;

function MakeVideoTag(fn,w,h,cfn){
   if (has_h264==""){
     s='<object type="application/x-shockwave-flash" data="player_flv_maxi.swf" width='+(w==null?640:w)+' height='+(h==null?480:h)+'>'
     s+='<param name="movie" value="player_flv_maxi.swf" />'
     s+='<param name="FlashVars" value="flv='+fn+'&amp;startimage='+(cfn!=""?cfn:"default_flvideo_cover.jpg")+'" />'
     s+="</object>"
   } else {     
     s='<div style="position:relative"><video id="video'+videoCnt+'" controls '+(autoPlay && videoCnt==0?" autoplay ":"")+(w!=null?" width="+w:"")+" "+(h!=null?" height="+h:"")+" "+(cfn!=""?" poster="+cfn:"")+' onended="video_end('+videoCnt+')" class="noFocus"><source src="'+fn+'"></video><div id="video'+videoCnt+'bg" class="videodelay_divwhite" style="'+(w!=null?"width:"+w+"px;":"")+(h!=null?" height:"+h+"px;":"")+'"></div><div class="videodelay_divlink" style="'+(w!=null?"width:"+w+"px;":"")+'" id="video'+videoCnt+'_div"><img class="videodelay_img" onclick="video_next('+videoCnt+')" id="img'+videoCnt+'" style="'+(h!=null?'margin-top:'+((h-64)/2)+"px;":"")+'margin-bottom:25px;" src="" /><a class="videodelay_canc" style="'+(w!=null?'margin-left:'+((w-54)/2)+'px':"")+'" onclick="video_stop('+videoCnt+')" href="javascript:void(0);"><span class="txt_annulla"></span></a></div></div>';
	 videoCnt++;
  }
  document.write(s)
}

var startOk = false;

function video_end(n){
  var v1=document.getElementById("video"+n);
  var v2=document.getElementById("video"+(n+1));
  if(v1.ended && v2!=null){
    var v1_d=document.getElementById("video"+n+"_div");
    var v1_bg=document.getElementById("video"+n+"bg");
    var img1=document.getElementById("img"+n);
    v1_d.style.display="block";
    img1.src="timeout.gif";
    v1_bg.style.display="block";
    setTimeout(function(){
      video_start(n);
      startOk=false;
    }, 4900);
  }
}

function video_next(n){ video_start(n); }
function video_stop(n){ startOk=true; video_start(n);}

function video_start(n){
  var v1=document.getElementById("video"+(n));
  var v2=document.getElementById("video"+(n+1));
  var v1_d=document.getElementById("video"+n+"_div");
  var v1_bg=document.getElementById("video"+n+"bg");
  var img1=document.getElementById("img"+n);
  var fse=document.fullscreenElement || document.webkitFullscreenElement || document.mozFullScreenElement || document.msFullscreenElement
  v1_d.style.display="none";
  img1.src="";
  v1_bg.style.display="none";
  if(!startOk){
    startOk=true;
    if (v2!=null && (fse==null || fse!=v1)){
      window.location.href='#video'+(n+1);
      v2.play();
    }
  }
}

function hasAns(ans){
  if (ans.type=="radio" || ans.type=="checkbox") {
    return ans.checked 
  }  
  return ans.value!=""
}

function evaluateAns(ans,r,i,j,ok){
  var anstype,usrres,res,c,rok,cmt
  anstype=ans.type
  res=ok
  c=document.getElementById("QANSW"+(i+1)+"_"+(j+1))  
  cmt=document.getElementById("QCMT"+(i+1)+"_"+(j+1))
  if (anstype=="radio") {
    if (ans.checked) {     
      if (res) res=(r[j+1]==1)
      c.style.color=(r[j+1]==1?"green":"red")
      if (c.parentNode.className=="s_pos") c.parentNode.style.border="solid 2pt "+(r[j+1]==1?"green":"red")
      if (cmt) cmt.style.display="block"
    }
    if (qmode==1) {
      ans.checked=false    
      c.style.color="black"
      if (cmt) cmt.style.display="none"
      if (c.parentNode.className=="s_pos") c.parentNode.style.border=""
    }
  } else if (anstype=="checkbox") {
    if (ans.checked) { 
       if (res) res=(r[j+1]==1)
       c.style.color=(r[j+1]==1?"green":"red")
       if (cmt) cmt.style.display="block"
       if (c.parentNode.className=="s_pos") c.parentNode.style.border="solid 2pt "+(r[j+1]==1?"green":"red")
    } else {
       if (res) res=(r[j+1]!=1)
       if (r[j+1]==1) c.style.color="red"
       if (r[j+1]==1 && c.parentNode.className=="s_pos") c.parentNode.style.border="solid 2pt red"
    }
    if (qmode==1) {
      ans.checked=false    
      c.style.color="black"
      if (cmt) cmt.style.display="none"
      if (c.parentNode.className=="s_pos") c.parentNode.style.border=""
    }
  } else if (anstype=="text") {
    usrres=ans.value
    rok=r[j+1].toLowerCase()==usrres.toLowerCase()
    if (res) res=rok
    c.style.color=(rok?"green":"red")
    if (qmode==1) {
      ans.value=""    
      c.style.color="black"
      if (cmt) cmt.style.display="none"
    } else {
      if (cmt) cmt.style.display="block"
    } 
  }  
  return res;
}

var qmode=0

function evaluateQuiz(r,nd){
  var i,j,qn,ans,esatte=0,errate=0,s="<ol>",c,ok,rr,frm
  var rpl=new Array()  
  // controlla a quali domande  stata data una risposta
  for(i=0;i<nd;i++){
    frm=document.forms['quiz'+(i+1)]
    qn="frm.QANSW"+(i+1)
    ans=eval(qn)
    if (ans!=undefined){
      if (ans.length==undefined){
        rpl.push(hasAns(ans))
      } else {
        replied=false
        for(j=0;j<ans.length;j++){
          replied=replied || hasAns(ans[j]) 
        }
        rpl.push(replied)
      }
    }
  }
  // valuta la risposta
  for(i=0;i<nd;i++){
    rr=eval("new Array("+LZW.decode(Base64.decode(r[i]))+")")
    frm=document.forms['quiz'+(i+1)]
    qn="frm.QANSW"+(i+1)
    ans=eval(qn)
    if (ans!=undefined){
      ok=true
      if (ans.length==undefined){
        if (rpl[i]) ok=evaluateAns(ans,rr,i,0,ok)
      } else {
        for(j=0;j<ans.length;j++){
          if (rpl[i]) ok=evaluateAns(ans[j],rr,i,j,ok)
        }
      }
      if (rpl[i]){
        if (ok) {
          s+='<li><span class="txt_exact"></span></li>'
          esatte++
        } else {
          s+='<li><span class="txt_wrong"></span></li>'
          errate++
        }
      } else {
        s +="<li>--</li>"    
      }
    } else {
      s +="<li>--</li>"        
    }
  }
  c=document.getElementById("quizresult")
  c.innerHTML=(qmode==0?s+"</ol><br/>"+esatte+" "+(esatte==1?'<span class="txt_1respok"></span>':'<span class="txt_respok"></span>')+", "
                                      +errate+" "+(errate==1?'<span class="txt_1respno"></span>':'<span class="txt_respno"></span>')+", "
									  +(nd)+' <span class="txt_questions"></span>.'
				       :"")
  qmode=(qmode==0?1:0)
  c=document.getElementById("quizbtn_eval")
  c.style.display=(qmode==0?"inline-block":"none")
  c=document.getElementById("quizbtn_restart")
  c.style.display=(qmode==0?"none":"inline-block")
}

function hooverSpot(spotClass, status) {
  var spotEl,ctrl,i,evidClass
  spotEl = document.getElementsByClassName('_spot_'+spotClass); 
  for(i=0;i<spotEl.length;i++){
	ctrl=spotEl[i]
	evidClass=(ctrl.classList.contains('spotText')?'spotTextHoover':'spotAreaHoover')
	if (status)
	  ctrl.classList.add(evidClass)	
	else	
      ctrl.classList.remove(evidClass)		
  }
}

function collapseExpand(ctrl){
  var note
  if (ctrl && ctrl.parentNode); // the "p"
        note = ctrl.parentNode.nextElementSibling; // the note after the "p"
  if (note){
    if (!note.style.display || note.style.display === "" || note.style.display === "none")
      note.style.display = "block";
    else
      note.style.display = "none";
  }
}

function onIdxLinkUpd(src) {
  var idxEls=document.getElementsByClassName('IndexLink');
  var i  
  for (i = 0; i < idxEls.length; i++) {
    idxEls[i].classList.remove('idxcurr');
	if (idxEls[i].href==src) 
      idxEls[i].classList.add('idxcurr');
  }
}

if (window.parent) window.parent.postMessage(window.location.href,'*')
  
function toggleIndex(){
  var ctr=document.getElementById("pgidx")
  if (ctr.classList.contains("popped"))
    ctr.classList.remove("popped")
  else
    ctr.classList.add("popped")
}